// IntExample.cpp : Defines the entry point for the console application.
//
#include "stdafx.h"
#include <stdio.h>
#include "manager.h"

int _tmain(int argc, _TCHAR* argv[])
{
	IUnique *theONE, *theSecond;

	CreateObject(EXIID_IUnique, (void**) &theONE);
	printf("\nPrvni rozhrani IUnique: 0x%08p\n", theONE);
	if(theONE)
	{
		theONE->Start("Toto je unikatni objekt.");
		theONE->Message();
		
		CreateObject(EXIID_IUnique, (void**) &theSecond);
		printf("Nove rozhrani IUnique: 0x%08p\nJe videt, ze ukazatele jsou stejne.\n", theSecond);

		printf("Druhe rozhrani vypisuje zpravu:\n");
		theSecond->Message();

		printf(" - Zprava je porad stejna.\n\n");

		theONE->Release();
		theSecond->Release();
	}

	printf("\n\n********************\n\n");

	ISpaceship	*ship1, *ship2;
	CreateObject(EXIID_ISpaceship, (void**) &ship1);
	CreateObject(EXIID_ISpaceship, (void**) &ship2);
	if(ship1 && ship2)
	{
		printf("\nPrvni rozhrani ISpaceship: 0x%08p\n", ship1);	
		printf("Druhe rozhrani ISpaceship: 0x%08p\n", ship2);
		printf(" - Je videt, ze ukazatele se lisi = DVA RUZNE OBJEKTY!\n");

		ship1->Init(5);
		printf("\nPozice prvni rakety:\n");
		ship1->Display();

		ship2->Init(3);
		printf("Pozice druhe rakety:\n");
		ship2->Display();

		ship1->Move(11);
		printf("\nPrvni raketa se pohnula o 11 a to nema zadny vliv na druhou raketu.\n");
		ship1->Display();
		ship2->Display();

		printf("\n");
		ship1->Release();
		ship2->Release();
	}

	getchar();

	return 0;
}

