#include "StdAfx.h"
#include ".\spaceship.h"

CSpaceship::CSpaceship(void)
{
	printf("CSpaceship::CSpaceship(void)\n");
	m_ulRef = 0;
	m_iPosition = 0;
}

CSpaceship::~CSpaceship(void)
{
	printf("CSpaceship::~CSpaceship(void)\n");
}

void CSpaceship::Init(int position)
{
	m_iPosition = position;

}

void CSpaceship::Move(int direction)
{
	m_iPosition += direction;
}

void CSpaceship::Display()
{
	printf("Position: %d\n", m_iPosition);
}

HRESULT		CSpaceship::AddRef()
{
	return m_ulRef++;
}

HRESULT		CSpaceship::Release()
{
	if(m_ulRef > 0)
	{
		m_ulRef--;
	}
	if(m_ulRef == 0)
	{			
		delete this;
		printf("Objekt CSpaceship byl znicen.\n");
		return 0;
	}	
	else
	{
		return m_ulRef;
	}	
}