#include "StdAfx.h"
#include ".\unique.h"

CUnique::CUnique(void)
{
	printf("CUnique::CUnique(void)\n");
	m_ulRef = 0;
	m_szMessage = NULL;
}

CUnique::~CUnique(void)
{
	printf("~CUnique::CUnique(void)\n");
	if(m_szMessage)
	{
		delete [] m_szMessage;
	}
}

void CUnique::Start(char * message)
{
	/* uvolnit pamet pokud byla zprava jiz vytvorena */
	if(m_szMessage)
	{
		delete [] m_szMessage;
	}
	int iLen = (int)strlen(message);
	/* vytvorime novou zpravu */
	m_szMessage = new char[iLen * sizeof(char) + 1];
	m_szMessage[iLen] = 0;
	/* a prekopirujeme obsah */
	strncpy(m_szMessage, message, iLen);
}

void CUnique::Message()
{
	printf("Message: %s\n", m_szMessage);    
}

HRESULT		CUnique::AddRef()
{
	return m_ulRef++;
}

HRESULT		CUnique::Release()
{
	if(m_ulRef > 0)
	{
		m_ulRef--;
	}
	if(m_ulRef == 0)
	{			
		delete this;
		printf("Objekt CUnique byl znicen.\n");
		return 0;
	}	
	else
	{
		return m_ulRef;
	}	
}